/*
 Read/Set VFO-A Frequency		: 	FA
 Read/Set VFO-B Frequency		:	FB
 Select/Read Receiver VFO		:	FR
 Select/Read Fine Tune			:	FS
 Select/Read Transmitter VFO	:	FT
 Read Transceiver Status		:	IF
 Set/Read CW Keyer Speed		:	KS
 Read Current Mode				:	MD
 Set/Read Noise Blanker			:	NB
 Set/Read Speech Processor		:	PR
 Clear RIT Offset Frequency		:	RC
 Move RIT Down					:	RD
 Move RIT Up					:	RU
 Set/Read RIT Function			:	RT
 Set/Read DSP Low Frequency		:	SL
 Set/Read DSP High Frequency	:	SH
 Read S-Meter Status			:	SM
 Set/Read Squelch Level			:	SQ
 Turn TX ON						:	TX
 Turn RX ON						:	RX
 Read Transceiver Status		:	RS

 Set VFO-A Frequency
 Transmitted From PC (Assume the frequency is: 14.195MHz)
 FA00014195000;

 Read VFO-A Frequency
 Transmitted from PC
 FA;
 Response from TS-2000 (Assume the frequency is: 14.195MHz)
 FA00014195000;

 Set VFO-B Frequency
 Transmitted From PC (Assume the frequency is: 14.195MHz)
 FB00014195000;

 Read VFO-B Frequency
 Transmitted from PC
 FB;
 Response from TS-2000 (Assume the frequency is: 14.195MHz)
 FB00014195000;

 Select Receiver VFO
 Transmitted from PC
 FR0;	Select VFO-A
 FR1;	Select VFO-B

 Read Receiver VFO
 Transmitted from PC
 FR;
 Response from TS-2000
 FR0;	VFO-A selected
 FR1;	VFO-B selected

 Select Fine Tune (1Hz)
 Transmitted from PC
 FS0;	Fine Tune function OFF (Select 10Hz tuning rate)
 FS1;	Fine Tune function ON (Select 1Hz tuning rate)

 Read Fine Tune
 Transmitted from PC
 FS;
 Response from TS-2000
 FS0;	Fine Tune function OFF (10Hz tuning rate)
 FS1;	Fine Tune function ON (1Hz tuning rate)

 Select Transmitter VFO (See Split Mode Note)
 Transmitted from PC
 FT0;	Select VFO-A
 FT1;	Select VFO-B

 Read Transmitter VFO
 Transmitted from PC
 FT;

 Response from TS-2000
 FT0;	VFO-A selected
 FT1;	VFO-B selected

 Read transceiver ID number
 Transmitted from PC
 ID;
 Response from TS-480
 ID020;

 Read Transceiver Status
 Transmitted from PC
 IF;

 Response from TS-480
 IFp1p1p1p1p1p1p1p1p1p1p1 p2p2p2p2p2 p3p3p3p3p3 p4 p5 p6 p7p7 p8 p9 p10 p11 p12 p13 p14p14 p15;
 (Spaces between parameters only for clarity - these are not in the response string unless specified.)
 p1 = 11-digits of receiver frequency to 1Hz, example: 14.234567MHz = 00014234567
 p2 = 5 spaces
 p3 = 4-digits plus sign RIT frequency +/-nnnn Hz
 p4 = 0 = RIT Off, 1 = RIT On
 p5 = 0 = XIT Off, 1 XIT On (Not Applicable)
 p6 = 0 (Always 0)
 p7 = 2-digit Memory Channel number 00 - 99 (Not Applicable)
 p8 = 0 = RX, 1 = TX
 p9 = 1 = LSB, 2 = USB, 3 = CW, 8 = TUNE
 p10 = 0 = VFO A, 1 = VFO B
 p11 = 0 = Scan Off
 p12 = 0 = Simplex, 1 = Split
 p13 = 0 (Not Applicable)
 p14 = 00 (Not Applicable)
 p15 = Space character

 Example 1: IF00014003920     +00000000002000000 ;
 RX Freq: 14.003920MHz RIT Freq: 0000, RIT Off, RX, USB, VFO A, Scan Off, Simplex 
 Example 2: IF00014003920     +01231000012000000 ;
 RX Freq: 14.003920MHz RIT Freq: +123, RIT On, TX, USB, VFO A, Scan Off, Simplex 
 Example 3: IF00014003920     -01231000002000000 ;
 RX Freq: 14.003920MHz RIT Freq: -123, RIT On, RX, USB, VFO A, Scan Off, Simplex 
 Example 4: IF00014003920     +00000000002001000 ;
 RX Freq: 14.003920MHz RIT Freq: +0000, RIT Off, RX, USB, VFO A, Scan Off, Split

 Set CW Keyer Speed
 Transmitted from PC
 KSnnn;
 Where nnn = 010 = 10wpm to 060 = 60wpm

 Read CW Keyer Speed
 Transmitted from PC
 KS;
 Response from TS-2000
 KSnnn;
 Where nnn = 010 = 10wpm to 060 = 60wpm

 Set Mode
 Transmitted from PC
 MD1;	LSB
 MD2;	USB
 MD3;	CW
 MD7;	CWR
 MD8;	TUNE

 Read Current Mode
 Transmitted from PC
 MD;

 Response from TS-2000
 MD1;	LSB
 MD2;	USB
 MD3;	CW
 MD7;	CW-R
 MD8;	Reserved - Used for TUNE in TRX-2

 Set Noise Blanker
 Transmitted from PC
 NB0;	Noise Blanker OFF
 NB1;	Noise Blanker ON

 Read Noise Blanker
 Transmitted from PC
 NB;
 Response from TS-2000
 NB0;	Noise Blanker OFF
 NB1;	Noise Blanker ON

 Set Speech Processor
 Transmitted from PC
 PR0;	Speech Processor OFF
 PR1;	Speech processor ON

 Read Speech Processor
 Transmitted from PC
 PR;
 Response from TS-2000
 PR0;	Speech Processor OFF
 PR1;	Speech processor ON

 Clear RIT Offset Frequency
 Transmitted from PC
 RC;

 Move RIT Down
 Transmitted from PC
 RDnnnnn;	Where nnnnn = 00000 to 99999 Hz

 Move RIT Up
 Transmitted from PC
 RUnnnnn;	Where nnnnn = 00000 to 99999 Hz

 Set RIT Function
 Transmitted from PC
 RT0;	RIT OFF
 RT1;	RIT ON

 Read RIT status
 Transmitted from PC
 RT;
 Response from TS-2000
 RT0;	RIT OFF
 RT1;	RIT ON

 Set DSP Low Frequency Settings
 Transmitted from PC
 SLnn;

 Read DSP Low Frequency Settings
 Transmitted from PC
 SL;
 Response from transceiver
 SL00;	Essentially, ignore, but satisfy the program

 Set DSP High Frequency Settings
 Transmitted from PC
 SHnn;

 Where nn has the following meanings:

 00	1,400Hz
 01	1,600Hz
 02	1,800Hz
 03	2,000Hz
 04	2,200Hz
 05	2,400Hz
 06	2,600Hz
 07	2,800Hz
 08	3,000Hz
 09	3,400Hz
 10	4,000Hz
 11	5,000Hz

 The TRX2 Narrow filter has a range of bandwidths from 500Hz to 1,293Hz
 The TRX2 Wide filter has a range of bandwidths from 1,293Hz to 2,500Hz
 
 If the Kenwood settings are implemented as shown, then the Narrow CW active filter would never be selected.
 In addition, bandwidth settings greater than 2,6kHz would have no effect. In order to optimally utilise the
 capabilities of the Juma TRX-2 The following bandwidths are selected instead of the original Kenwood settings:
 
 00	500Hz
 01	700Hz
 02	900Hz
 03	1,100Hz
 04	1,300Hz
 05	1,500Hz
 06	1,700Hz
 07	1,900Hz
 08	2,100Hz
 09	2,300Hz
 10	2,500Hz
 11	2,700Hz

 Read DSP High Frequency Settings
 Transmitted from PC
 SH;
 Response from transceiver
 SHnn;

 Where nn has the same meanings as for the set command, except that the modified settings are used.

 Read S-Meter Status
 Transmitted from PC
 SM0;	Main transceiver S-Meter
 SM1;	Sub-receiver
 SM2;	Main transceiver S-Meter level
 SM3;	Sub-receiver S-Meter level

 Response from TS-2000
 SM0nnnn;
 SM1nnnn;
 SM2nnnn;
 SM3nnnn;	Where nnnn is 0000 - 0030 (main receiver) 0000 - 0015 (Sub receiver)

 Set Squelch
 Transmitted from PC
 SQ0nnn;	Set squelch level Main transceiver where nnn = 000 - 255
 SQ1nnn;	Set Squelch level Sub receiver where nnn = 000 - 255

 Read Squelch Level
 Transmitted from PC
 SQ0;	Read Main transceiver level
 SQ1;	Read sub-receiver squelch level
 Response from TS-2000
 SQ0nnn;
 SQ1nnn; Where nnn = 000 - 255

 Turn TX ON
 Transmitted from PC
 TX0;	Transmit from MIC (TS-480)
 TX;	Transmit (TS-2000) If TS-2000 is already in transmit mode, response is ?; otherwise no response.
 Response from TS-480
 TX0;

 Turn RX ON
 RX;
 Response from TS-480
 RX0;
 No response from TS-2000. If TS-2000 is already in RX mode, response is: ?;

 Read Transceiver Status
 Transmitted from PC
 RS;
 Response from TS-480
 RS0;	Normal
 RS1;	Busy

 Set Extended Display Mode	- Not in TS-480 protocol!
 Transmitted from PC
 XD0;	Normal Display
 XD1;	O/P Power
 XD2;	SWR
 XD3;	Voltmeter
 XD4;	Ammeter

 Read Extended Display Mode	- Not in TS-480 protocol!
 Transmitted from PC
 XD;
 Response from TRX-2
 XD0;	Normal Display
 XD1;	O/P Power
 XD2;	SWR
 XD3;	Voltmeter
 XD4;	Ammeter

 Lock Current VFO - Not in TS-480 protocol!
 Transmitted from PC
 XL1;

 Unlock Current VFO - Not in TS-480 protocol!
 Transmitted from PC
 XL0;

 Split Mode
 To enable Split Mode first set the frequency of VFO-B. This will be accomplished by the FB command,
 then the FT1; command will be sent to use VFO-B as the transmit VFO, then set the receive VFO as A,
 this is accomplished with the FR0; command. Since the transmit VFO is VFO-B, and the receive VFO is VFO-A
 this activates the split mode on in the TRX2. To deactivate split mode, set the receive VFO as VFO-B with
 the FR1; command, since the receive VFO is now VFO-B, this cannot be split mode, and it is now deactivated.
 The logic does not allow the transmit VFO to be VFO-A and the receive VFO to be VFO-B.
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "trx2_eeprom.h"			// Get EEPROM structure definitions
#include "juma-trx2.h"

#define MAX_KENWOOD_CMD	14			// Maximum number of command characters

// External Variables
// User Configuration Data
extern struct
	{
	struct defval defval;
	} eeprom;

extern int s_meter;
extern int PTT_IN;
extern int vfo_idx;
extern int rit;
extern int old_vfo;
extern int split_flag;
extern int sub_page0;
extern int cmd_buf_idx;				// Defined in serial_trx2.c
extern unsigned char cmd_buf[];		// Defined in serial_trx2.c

// External Functions
extern int kbhit(void);
extern unsigned char getch(void);
extern void set_bit(int);
extern void clr_bit(int);
extern void max_min(int *, int, int);
extern void clear_buffer(void);		// Defined in serial_trx2.c

// Local Variables
int tx_vfo;							// Transmit VFO, 0 = VFO-A, 1 = VFO-B
int rx_vfo;							// Receiver VFO, 0 = VFO-A, 1 = VFO-B
int _vfo;							// Local VFO state

// Standard Command Format Messages
const char frequency_format[] = {"%2s%011li%c"};
const char FS_msg[] = {"FS%1i;"};
const char FR_msg[] = {"FR%1i;"};
const char FT_msg[] = {"FT%1i;"};
const char ID_msg[] = {"ID020;"};
const char IF_msg[] = {"    %+05d%c0000%c%c%c0%c000 ;"};
const char MD_msg[] = {"MD%c;"};
const char NB_msg[] = {"NB0;"};
const char PR_msg[] = {"PR%1i;"};
const char RT_msg[] = {"RT%1i;"};
const char SL_msg[] = {"SL04;"};
const char SH_msg[] = {"SH%02i;"};
const char SM_msg[] = {"SM0%04i;"};
const char RS_msg[] = {"RS0;"};
const char XD_msg[] = {"XD%1i;"};
const char Unknown_msg[] = {"?;"};

/*
  The state of a Kenwood transceiver is determined by the state of its individual VFOs. There is
  no explicit command to select the SPLIT mode state, nor one to de-select it. There are two
  VFOs, VFO-A, and VFO-B the ultimate state of the transceiver is determined by the following
  state table where VFO-A = 0, and VFO-B = 1 :

  rx_vfo	tx_vfo	eeprom.defval.vfo_sel
  =======================================
    0          0             0				// Non-SPLIT, VFO-A is used for TX and RX
	1          0             ?				// VFO-B is used for RX, VFO-A is used for TX, illegal state
	0          1             2				// SPLIT, VFO-A is RX, VFO-B is TX
	1          1             1				// Non-SPLIT, VFO-B is used for TX and RX
  =======================================
*/
void select_state(void)
	{
	if(rx_vfo ^ tx_vfo) eeprom.defval.vfo_sel = 2;
	else eeprom.defval.vfo_sel = rx_vfo;
	}

/*
  Although the obvious way of implementing this function is to use a switch-case construct, since
  the values are positively determined in the transceiver's main code, this permits a simpler
  method. This simpler method resulted in a code saving of 57 bytes.
*/
char get_vfo_mode(void)
	{
	int mode;

	if(PTT_IN) _vfo = rx_vfo;	// Receive
	else _vfo = tx_vfo;			// Transmit

	mode = eeprom.defval.mode[_vfo] + '1';	// Make the mode character ASCII 1 through 5

	if(mode > '3') mode += 3;	// If the mode is CWR/TUNE, make the ASCII symbol 7/8

	return mode;
	}

void serial_kenwood(void)
	{
	unsigned long freq;
	unsigned int cmd, request, tmp = 0;
	unsigned char c;

	if(cmd_buf_idx > MAX_KENWOOD_CMD)	// Are we about to over-run the receive buffer?
		{								// Yes, so clear the buffer and abort.
		clear_buffer();
		return;
		}

	if(kbhit())							// Are there any characters in the RX queue?
		{
		c = toupper(getch());			// Get next character converted to upper case,
		cmd_buf[cmd_buf_idx++] = c;		// place in the buffer, and increment the index,

		if(c != ';') return;			// and return, if not at end of command string

		if(cmd_buf[2] == ';')			// This is the end of a command,
			request = TRUE;				// so set the request flag.
		else							// This is a parameter,
			{
			freq = atol(cmd_buf + 2);	// so make the parameter a number.

			if(freq > 30000000UL)		// This is the maximum frequency.
				freq = 30000000UL;

			if(freq < 65536UL)			// This is a parameter value, not a frequency.
				tmp = (unsigned int)freq;

			request = FALSE;			// Clear the request flag.
			}
// The command is formed by shifting the first character into the upper half of the
// command word, and then adding the second character.
		cmd = (cmd_buf[0] << 8) + cmd_buf[1];

// Now get current state
		if(split_flag)
			{
			tx_vfo = 1;
			rx_vfo = 0;
			}
		else
			tx_vfo = rx_vfo = eeprom.defval.vfo_sel;

// Now let's look to see what command we've received.
		switch(cmd)
			{
			case 0x4641:						// FA - Set/Read Frequency of VFO-A
				if(request)
					printf(frequency_format, "FA", eeprom.defval.vfo[0], ';');
				else							// This is a set frequency command
					eeprom.defval.vfo[0] = freq;
			break;

			case 0x4642:						// FB - Set/Read frequency of VFO-B
				if(request)
					printf(frequency_format, "FB", eeprom.defval.vfo[1], ';');
				else							// This is a set frequency command
					eeprom.defval.vfo[1] = freq;
			break;

			case 0x4653:						// FS Set/Read Fine Tune
				if(request)						// Send the current step index. Note: Even the 100Hz/1kHz steps will be shown as a 10Hz increment!
					printf(FS_msg, !eeprom.defval.step_idx);
				else							// This is a command. If tmp == 0, then turn off 1Hz rate. (Turn on 10Hz rate)
					eeprom.defval.step_idx = (tmp == 0);
			break;

			case 0x4652:						// FR - Read/Select Receive VFO
				if(request)
					printf(FR_msg, rx_vfo);
				else							// This is a command
					{
					rx_vfo = tmp;

					if(rx_vfo == 1)				// If VFO-B is set to receive, then force
						tx_vfo = 1;				// the transmit VFO to be B. This eliminates the illegal TX = A, RX = B state.

					select_state();
					}
			break;
/*
  This request/command requires special consideration. A Kenwood transceiver only has two active VFOs,
  VFO A or VFO B. The TRX-2 can have as many as 26 'active' VFOs, and there is no way for a CAT program
  dealing with a Kenwood to take account of this. In order for some sort of logic to prevail, in the
  User Setup menu if either the Kenwood CAT or the Yaesu CAT mode is selected for the serial port then
  the mode defaults to A/B + Split. If an attempt is made to change this, it is not allowed.
  Now, if VFO-A or VFO-B is set to be the receive VFO, then we are operating in simplex mode, and
  eeprom.defval.vfo_sel is set to either 0 (VFO-A) or 1 (VFO-B).
  If VFO-B is selected as the transmit VFO, then eeprom.defval.vfo_sel is forced to 2, VFO-A is forced
  to receive. If the receive and transmit VFOs are set to be the same, then eeprom.defval.vfo_sel is
  restored to either 0 or 1.
*/
			case 0x4654:						// FT Select/Read the Transmit VFO
				if(request) printf(FT_msg, tx_vfo);
				else							// This is a command
					{
					tx_vfo = tmp;

					if(tx_vfo == 0)				// If VFO-A is set to transmit, then force
						rx_vfo = 0;				// the receive VFO to be A. This eliminates the illegal TX = A, RX = B state.

					select_state();
					}
			break;

			case 0x4944:						// ID - Read Transceiver ID
				printf(ID_msg);					// Send TS-480 ID number
			break;

			case 0x4946:						// IF - Request transceiver information
				c = get_vfo_mode();				// This sets the state of _vfo as well as getting the mode letter
				printf(frequency_format, "IF", eeprom.defval.vfo[_vfo], ' ');
				printf(IF_msg, rit, eeprom.defval.rit_on + '0', (!PTT_IN + '0'), c, (_vfo + '0'), (split_flag + '0'));
			break;

//			case 0x4B53:						// KS - CW Keyer speed (Not Implemented)
//			break;

			case 0x4D44:						// MD - Set/Read Current Mode
				if(request)
					printf(MD_msg, get_vfo_mode());
				else							// This is a command
					{
					switch(tmp)
							{
							case 1: case 2: case 3:
								eeprom.defval.mode[vfo_idx] = tmp - 1;
							break;

							case 7: case 8:		// Not supported by all transceivers
								eeprom.defval.mode[vfo_idx] = tmp - 4;
							break;

							default:
								if(eeprom.defval.vfo[vfo_idx] > 10000000L)
									eeprom.defval.mode[vfo_idx] = USB;
								else
									eeprom.defval.mode[vfo_idx] = LSB;
							}
					}
			break;

			case 0x4E42:						// NB - Set/Read Noise Blanker
				if(request)
					printf(NB_msg);				// Noise Blanker is always OFF
			break;								// The command is ignored, the TRX-2 does not have a noise blanker.

			case 0x5052:						// PR - Speech Processor
				if(request)
					printf(PR_msg, eeprom.defval.proc_on_off);
				else							// This is a command
					eeprom.defval.proc_on_off = (tmp == 1); // If tmp == 0, turn off processor.
			break;

//			case 0x5243:						// RC - Clear RIT offset frequency
//			break;

//			case 0x5244:						// RD - Move RIT frequency down
//			break;

//			case 0x5255:						// RU - Move RIT frequency up
//			break;

			case 0x5254:						// RT - Set/Read RIT function
				if(request)
					printf(RT_msg, eeprom.defval.rit_on);
				else							// This is a command
					eeprom.defval.rit_on = (tmp == 1);
			break;

			case 0x534C:						// SL - Set/Read DSP Filter Low Frequency settings
				if(request)
					printf(SL_msg);				// Respond with 300Hz
			break;

			case 0x5348:						// SH - Read/Set DSP filter High Frequency settings
				if(request)
					{
					tmp = (int)((75000L / eeprom.defval.scaf_filters[eeprom.defval.filter]) - 500L);	// See note on Line 230
					printf(SH_msg, tmp / 200);
					}
				else							// This is a command
					max_min(&tmp, 11, 0);		// Ensure tmp is within legal range
					eeprom.defval.filter = (tmp > 1) ? 1 : 0;								// Select Wide or Narrow filter
					eeprom.defval.scaf_filters[eeprom.defval.filter] = (int)(75000L / (500 + (200 * tmp)));	// See note on Line 230
			break;

			case 0x534D:						// SM - Read the S-Meter
				printf(SM_msg, (s_meter * 10) / 24);
			break;

			case 0x5458:						// TX
				PTT_OUT = 1;					// Turn transmitter ON
			break;

			case 0x5258:						// RX
				PTT_OUT = 0;					// Turn receiver ON
			break;

			case 0x5253:						// RS
				printf(RS_msg);					// Return 'Normal'
			break;

			case 0x5844:						// XD Read/Set Extended Display
				if(request)
					printf(XD_msg, sub_page0);
				else							// This is a command
					{
					tmp %= 5;					// sub_page0 displays from 0 to 4
					sub_page0 = tmp;
					}
			break;

			case 0x584C:						// XL Lock/Unlock Current VFO
				if(tmp)
					set_bit(vfo_idx);
				else
					clr_bit(vfo_idx);
			break;

			default:							// None of the above
				printf(Unknown_msg);
			break;
			}

		clear_buffer();							// Clear buffer and reset index
		}
	}

