				if(_VFAST)									// Allow Tuning Rate changes only in Receive and not in Setup or Configuration Mode
					{
					bl_on();
					button_debounce(_VFAST);

					if(delay_time)					// ****** PRIMARY Function ******
						{
						if(eeprom.defval.step_idx == KILO_HZ)		// If the Very Fast tuning rate is already selected,
							eeprom.defval.step_idx = TEN_HZ;		// then return to 10Hz rate (Medium).
						else										// Increment tuning rate
							increment_and_check(&eeprom.defval.step_idx, 3);
						}
					else							// ****** SECONDARY Function ******
						{
						if(eeprom.defval.cw_annunciation)			// If CW Annunciation is enabled,
							{
							if(eeprom.defval.step_idx == KILO_HZ) eeprom.defval.step_idx = TEN_HZ;	// If the Very Fast tuning rate is selected, then return to the 10Hz rate (Medium).

							cw_status = (eeprom.defval.cw_annunciation & 0x0001) ? 0x001F : 0x0018;	// Set the CW Status flag
							break;	// Is this necessary?
							}
						else										// Verfy fast tuning rate select or exit
							{
							eeprom.defval.step_idx = (eeprom.defval.step_idx == KILO_HZ)
								? ONE_HZ							// If the Very Fast tuning rate is already selected, then return to the 1Hz (Slow) rate, 
								: KILO_HZ;							// or, if not, select the Very Fast tuning rate.
							break;	// Is this necessary?
							}
						}

					lcd_cmd(LINE2PLUS15);
					lcdoutch(tuning_step[eeprom.defval.step_idx]);	// This displays the tuning step immediately
					snap_to_step();									// Round VFO frequency to current step size, if enabled.

					if(eeprom.defval.cw_annunciation) beep(HZ587_31, cal.calval.beep_len);
					else beep(status_beep[eeprom.defval.step_idx], cal.calval.beep_len);

					wait_FAST_VFAST_rls();							// Wait for button release
					debounce();										// Button debounce and encoder reset
					}

