				if(_VFO)											// Do not change if TX is ON, or if in User Setup Mode!
					{
					bl_on();
					button_debounce(_VFO);

					if(delay_time)				// ****** PRIMARY Function ******
						{
						increment_and_check(&eeprom.defval.vfo_sel, (eeprom.defval.max_vfo == SPLIT_MODE) ? 3 : eeprom.defval.max_vfo);

						if(eeprom.defval.cw_annunciation) cw_status = 0x0014;
						beep_number = (eeprom.defval.vfo_sel == VFO_A) ? 1 : 2;
						}
					else						// ****** SECONDARY Function ******
						{
						if(eeprom.defval.max_vfo == SPLIT_MODE)		// ***** A/B + Split Mode *****
							{
							eeprom.defval.mode[SPLIT_MODE] = LSB;			// Bug fix, Split mode phantom VFO #2 should never be in Tune mode (Mode = 3), 03.07.2008

							if(eeprom.defval.vfo_sel == SPLIT_MODE)			// If we are in the SPLIT mode...
								{
								if(hold_latch == LATCH)					// **** Latched Mode ****
									{
									latch = TRUE;
									Toggle_VFO_Lock(FALSE);					// Immediately display VFO Toggle message
									while(_VFO) warning_beep();				// Immediately start warning beep and wait for button release
									synch_beep();

									do	{
										warning_beep();
										Toggle_VFO_Lock(TRUE);				// PWR button is used to toggle the lock

										if(_VFO)							// Latched mode can only be released with VFO button
											{
											latch = FALSE;					// Release the page hold latch
											beep_number = 2;
											}
										} while(latch);
									}
								else									// **** Push & Hold Mode ****
									{
									beep(HZ466_85, cal.calval.beep_len * 5);// Long beep for Push & Hold mode
									reset_encoder();						// Avoids VFO change if VFO knob rotated whilst initially holding button
									while(_VFO) Toggle_VFO_Lock(TRUE);
									}
								}
							else									// ***** Simplex Mode *****
								{
								beep(HZ466_85, cal.calval.beep_len * 5);	// Long beep for VFO A to B or B to A copy

								if(vfo_idx == VFO_A)						// If VFO A is in use...
									{
									if(check_bit(VFO_B)) sprintf(lcdpbuff, vfo_locked, 'B');	// VFO-B Locked
									else
										{
										eeprom.defval.vfo[VFO_B] = eeprom.defval.vfo[VFO_A];		// Copy VFO-A frequency to VFO-B,
										eeprom.defval.mode[VFO_B] = eeprom.defval.mode[VFO_A];		// and also the mode,
										sprintf(lcdpbuff, copy_vfo, 'A', RIGHT_ARROW, mv[1], 'B');	// format the copy message,
										A_equals_B_flag = 2;
										}
									}
								else										// If VFO B is in use...
									{
									if(check_bit(VFO_A)) sprintf(lcdpbuff, vfo_locked, 'A');	// VFO-A Locked
									else
										{
										eeprom.defval.vfo[VFO_A] = eeprom.defval.vfo[VFO_B];		// Copy VFO-B frequency to VFO-A,
										eeprom.defval.mode[VFO_A] = eeprom.defval.mode[VFO_B];		// and also the mode,
										sprintf(lcdpbuff, copy_vfo, 'A', LEFT_ARROW, mv[1], 'B');	// format the copy message,
										A_equals_B_flag = 1;
										}
									}
								display_line(LINE2, lcdpbuff);										// and display either the locked or copy message.
								}
							break;
							}
						else										// ***** VFO Multi-Memory Mode *****
							{
							if(hold_latch == LATCH)				// **** Latched Mode ****
								{
								latch = TRUE;
								VFO_Select(FALSE);

								while(_VFO) warning_beep();						// Immediately start warning beep
								synch_beep();

								do	{
									warning_beep();
									VFO_Select(TRUE);							// Select and either lock or unlock the desired VFO

									if(_VFO)
										{
										latch = FALSE;							// Release the page hold latch
										beep_number = 2;
										}
									} while(latch);
								}
							else								//  **** Push & Hold Mode ****
								{
								beep(HZ466_85, cal.calval.beep_len * 5);		// Long beep for Push & Hold mode
								reset_encoder();								// Avoids spurious VFO change if VFO knob rotated whilst initially holding button
								while(_VFO) VFO_Select(TRUE);					// Select and either lock or unlock the desired VFO
								}
							break;	// Is this necessary?
							}
						}
					while(_VFO);								// Wait for VFO button release
					debounce();									// Button debounce and encoder reset
					}

